#include <string.h>
#include <pwd.h>

static char SccsId[] = "@(#)getlogdir.c	1.3\t4/13/93";

#ifndef NULL
#define NULL (char *) 0
#endif

int getlogdir(user, buf)
char *user;
char *buf;
{
    /* Gets the login directory of the named user, and puts it into buf.
     * If user==NULL || *user == '\0', the current user is obtained.
     * Best if buf is MAXPATHLEN long.
     * 0 is returned on success; -1 on error.
     */

    struct passwd *pass;
    char *p;
    char *getlogin();

    buf[0] = '\0';
    if (user != NULL && *user != '\0') {
	/* Name given; use getpwnam */
	pass = getpwnam(user);
    } else if ((p = getlogin()) != NULL) {
	/* No name given; use current login name */
	pass = getpwnam(p);
    } else {
	/* No user given && getlogin() returned NULL; use current uid */
	pass = getpwuid(getuid());
    }


    if (pass == (struct passwd *) NULL)
	return -1;

    (void) strcpy(buf, pass->pw_dir);

    return 0;
}
