#include <grp.h>

static char SccsId[] = "@(#)ingroup.c	1.5\t7/6/93";

/* Use:
 *	ingroup(user, gid, gp_pat)
 * Returns:
 *	1 if the user is in a group matching the regex pattern gp_pat.
 *	0 if the user isn't in a group matching the pattern.
 *	-1 if pattern failed to compile.

 * SIDE-EFFECT: uses re_comp! -- messes up caller's use of same!

 * Uses re_{comp,exec} routines to compare.

 * Examples:
 *	ingroup("joe", joes_gid, "xyz")
 * returns !0 if user joe is in group "xyz".
 *	ingroup("joe", joes_gid, "xy.*")
 * returns !0 if user joe is in any group matching "xy.*".

 */

ingroup(user, gid, gp_pat)
char *user;
int gid;
char *gp_pat;	/* pattern to match */
{
    char *re_comp();
    int re_exec();
    struct group *gp;
    char **mem;
    void setgrent();

    if (re_comp(gp_pat) != (char *)0 )
	return -1;

    /* Search group file for groups user's in.
     * Test for group matches wherever user belongs.
     */
    setgrent();
    for (gp = getgrent(); gp; gp = getgrent()) {
	/* gr_mem only shows names added in the /etc/groups file, not
	 * the group assigned in passwd.  Check that group (gp->gr_gid)
	 * explicitly, then check gp->gr_mem list.
	 */
	if (gid != gp->gr_gid) {
	    for (mem = gp->gr_mem; *mem ; mem++)
		if (strcmp(*mem, user) == 0)
		    break;
	    if (!*mem)
		continue;			/* not in group */
	}
	if (re_exec(gp->gr_name) == 1)	/* in group; compare gp name with pat */
	    return 1;
    }
    return 0;
}
