#include <ctype.h>

static char SccsId[] = "@(#)word.c	1.3\t4/13/93";

/* Returns a pointer to the start of the k'th word in s.
 * Numbering is that k=1 for the first word.
 * A pointer to a null string is returned if there is no k'th word.
 */

/*
 * Compile with -DPROGRAM to get a standalone program that's used as
 * 	$0  k  string
 * and prints the k'th whitespace-separated word of the string on stdout.
 */  

char *
word(s, sep, k)
register char *s;
register char *sep;	/* word separators */
int k;
{
    int i;
    
    /* Skip leading separators */
    s += strspn(s, sep);

    /* Skip words before the k'th word */
    for (i=1; i<k; i++) {
	if (*s) s += strcspn(s, sep);	/* Skip a word... */
	if (*s) s += strspn(s, sep);	/* ...and the trailing separators */
    }
    return s;
}    

#ifdef TEST
#include <stdio.h>
#include <string.h>
main(argc, argv)
int argc;
char **argv;
{
    char *prog, *word();
    int atoi();

    prog = strrchr(argv[0], '/');
    prog = (prog && *(prog+1)) ? prog+1 : (prog) ? prog : argv[0];
    if (argc != 3) {
	(void) fprintf(stderr, "Usage: %s  k  \"string\"\n", prog);
	(void) exit(1);
    }
    printf("%s\n", word(argv[2], " \t\v", atoi(argv[1])));
    return 0;
}
#endif
